'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 29 July 2002 at 11:13:01 pm'!
"Change Set:		MaArmoredCode
Date:			29 July 2002
Author:			Chris Muller

Extensions to the SUnit framework.  Notable is a new class, MaNetworkTestCase, for using *multiple* Squeak images to test network programs."!

MaSingleton subclass: #MaArmoredCodeOptions
	instanceVariableNames: 'testEnvironmentPath testingResourcesPath baseImageFileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-Base'!
MaObject subclass: #MaNetworkTestPlayer
	instanceVariableNames: 'testCase '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-Network testing private'!
MaObject subclass: #MaNetworkTestPlayerFacade
	instanceVariableNames: 'link name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-Network testing private'!
MaServerRequest subclass: #MaNetworkTestPlayerRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-private'!
MaNetworkTestPlayerRequest subclass: #MaPushCodeRequest
	instanceVariableNames: 'stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-private'!
MaNetworkTestPlayerRequest subclass: #MaRemoteEvaluateRequest
	instanceVariableNames: 'codeString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-private'!
MaNetworkTestPlayerRequest subclass: #MaRemotePerformRequest
	instanceVariableNames: 'selector arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-private'!
MaNetworkTestPlayerRequest subclass: #MaSetTestCaseClassRequest
	instanceVariableNames: 'testCaseClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-private'!
TestCase subclass: #MaTestCase
	instanceVariableNames: 'options '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit extensions-Base'!

!MaTestCase commentStamp: '<historical>' prior: 0!
Getting ready to try using "fixtureSpecs" so we can test against hundreds of fixtures easily.
!

MaTestCase subclass: #MaNetworkTestCase
	instanceVariableNames: ''
	classVariableNames: 'NextPort '
	poolDictionaries: ''
	category: 'SUnit extensions-Network testing'!

!MaNetworkTestCase commentStamp: '<historical>' prior: 0!
My subclasses are intended to test network programs.  I provide methods for communicating with other images and tunnelling requests to them.!

MaNetworkTestCase class
	instanceVariableNames: 'currentSuite '!

!MaArmoredCodeOptions methodsFor: 'accessing' stamp: 'cmm 5/6/2002 22:17'!
baseImageFileName

	^baseImageFileName! !

!MaArmoredCodeOptions methodsFor: 'accessing'!
testEnvironmentPath

	^testEnvironmentPath! !

!MaArmoredCodeOptions methodsFor: 'accessing' stamp: 'cmm 3/9/2002 17:34'!
testingResourcesPath

	^testingResourcesPath! !

!MaArmoredCodeOptions methodsFor: 'building' stamp: 'cmm 5/6/2002 22:17'!
baseImageFileName: aString

	baseImageFileName _ aString
! !

!MaArmoredCodeOptions methodsFor: 'building'!
testEnvironmentPath: aString

	testEnvironmentPath _ aString
! !

!MaArmoredCodeOptions methodsFor: 'building' stamp: 'cmm 3/9/2002 17:34'!
testingResourcesPath: aString

	testingResourcesPath _ aString! !

!MaArmoredCodeOptions methodsFor: 'private initializing' stamp: 'cmm 3/9/2002 17:34'!
initialize

	testEnvironmentPath _ self maEmptyString.
	testingResourcesPath _ self maEmptyString
! !


!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 5/7/2002 23:22'!
loadCodeFrom: aPositionableStream

	aPositionableStream position: 0.
	aPositionableStream fileInAnnouncing: 'loading code from conductor..'.
	^nil
! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 7/2/2002 22:42'!
protocol

	^MaNetworkTestPlayerRequest allSubclasses
		add: ReadWriteStream;  "for fileouts"
		add: SmallInteger;  "for getting changeSet versions"
		add: UndefinedObject; "we answer nil as a lightweight, non-interesting return value."
		add: LargePositiveInteger; "for returning an oid"
		addAll: testCase additionalProtocol;
		yourself! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/18/2002 23:36'!
remoteEvaluate: aString

	| result |
	result _ Compiler
		evaluate: aString
		for: testCase
		logged: true.
	^result == testCase
		ifTrue: [ nil ]
		ifFalse: [ result ]
! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/18/2002 23:37'!
remotePerform: selector withArguments: anArray

	| result |
	result _ testCase
		perform: selector
		withArguments: anArray.
	^result == testCase
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 5/27/2002 19:51'!
setTestCaseClass: aClass

	testCase _ aClass new.
	"No real response nececessary, but nil is a small response to serialize back.."
	^nil
! !

!MaNetworkTestPlayer methodsFor: 'request framework requirements' stamp: 'cmm 6/2/2002 21:37'!
processRequest: aMaNetworkTestPlayerRequest

	Transcript cr; show: 'Processing ', aMaNetworkTestPlayerRequest printString.
	^aMaNetworkTestPlayerRequest processFor: self
! !


!MaNetworkTestPlayer class methodsFor: 'as yet unclassified' stamp: 'cmm 5/6/2002 22:40'!
listenInNewImageOnPort: anInteger
	"Launch a new image on this machine, when the image starts, it should automatically be listeningon port anInteger."

"not implemented yet, for now, you'll have to start them yourself.."
! !

!MaNetworkTestPlayer class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2002 00:13'!
testCaseClass: aNetworkTestCaseClass

	^self new 
		setTestCaseClass: aNetworkTestCaseClass;
		yourself! !


!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/2/2002 23:58'!
connect

	link connect
! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 4/27/2002 14:50'!
link: aMaServerLink

	link _ aMaServerLink! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/8/2002 22:00'!
name: aString

	name _ aString! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 5/7/2002 00:01'!
pushChangeSetNamed: aString

	| stream |
	stream _ ReadWriteStream on: String new.
	(ChangeSorter changeSetNamed: aString) fileOutTo: stream.
	^self pushCode: stream
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 5/22/2002 17:32'!
pushClass: aClass

	| stream |
	stream _ ReadWriteStream on: String new.
	aClass
		fileOutOn: stream
		moveSource: false
		toFile: 0.
	^self pushCode: stream
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 5/12/2002 21:42'!
pushCode: aPositionableStream

	Transcript cr; show: 'pushing code to ', name.
	^link submit:
		(MaPushCodeRequest new
			stream: aPositionableStream;
			yourself)
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/9/2002 23:01'!
hostAddress

	^link hostAddress! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/22/2002 10:21'!
name

	^name
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/12/2002 22:03'!
remoteEvaluate: aString

	Transcript cr; show: name, ' is remote evaluating: '; cr; show: aString.
	^link submit:
		(MaRemoteEvaluateRequest new
			codeString: aString;
			yourself)
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/12/2002 21:40'!
remotePerform: selectorSymbol withArguments: anArray

	Transcript cr; show: 'remote performing ', selectorSymbol, ' with arguments ', anArray printString, ' in ', name.
	^link submit:
		(MaRemotePerformRequest new
			selector: selectorSymbol;
			arguments: anArray)
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/27/2002 20:16'!
setTestCaseClass: aClass
	"Make sure you have first updated the ChangeSet that contains your test case class, or the player may not be able to instantiate it."

	Transcript cr; show: 'setting test case class to ', aClass name, ' in ', name.
	^link submit:
		(MaSetTestCaseClassRequest new
			testCaseClass: aClass;
			yourself)
! !


!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 4/27/2002 14:12'!
hostAddress: aByteArray port: anInteger

	^self new link:
		(MaRemoteServerLink
			hostAddress: aByteArray
			port: anInteger)
! !

!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 5/8/2002 22:00'!
name: aString hostAddress: aByteArray port: anInteger

	^self new 
		name: aString;
		link:
			(MaRemoteServerLink
				hostAddress: aByteArray
				port: anInteger)
! !


!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream

	^stream
! !

!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream: aPositionableStream

	stream _ aPositionableStream! !

!MaPushCodeRequest methodsFor: 'private' stamp: 'cmm 5/6/2002 23:59'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer loadCodeFrom: self stream
! !


!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:32'!
codeString

	^codeString
! !

!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:32'!
codeString: aString

	codeString _ aString! !

!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:37'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer remoteEvaluate: codeString! !


!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments

	^arguments
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments: aSymbol

	arguments _ aSymbol
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector

	^selector
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector: aSymbol

	selector _ aSymbol
! !

!MaRemotePerformRequest methodsFor: 'private' stamp: 'cmm 4/27/2002 16:33'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer
		remotePerform: self selector
		withArguments: self arguments
! !


!MaRemoteServerLink methodsFor: 'private' stamp: 'cmm 4/28/2002 22:35'!
serverRefreshProtocol

	serializer classDefinitionsByteArray: (socket
		sendData: 'refr' asByteArray
		startingAt: 1
		count: 4
		waitForReplyIn: serializer byteArray 
		startingAt: 1)
! !


!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass

	^testCaseClass! !

!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass: aClass

	testCaseClass _ aClass! !

!MaSetTestCaseClassRequest methodsFor: 'private' stamp: 'cmm 5/27/2002 20:16'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer setTestCaseClass: self testCaseClass! !


!MaTestCase methodsFor: 'accessing' stamp: 'cmm 4/24/2002 23:24'!
environmentPath

	^MaArmoredCodeOptions current testEnvironmentPath
! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 4/24/2002 23:22'!
resourcesPath

	^MaArmoredCodeOptions current testingResourcesPath
! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 2/17/2002 21:24'!
deleteFilesNamed: aCollection

	aCollection do:
		[ :each |
		StandardFileStream allInstances do:
			[ :eachStream |
			eachStream fullName = each ifTrue:
				[ Transcript cr; show: 'closing a rogue FileStream for ', eachStream fullName.
				eachStream close ] ].
		Transcript cr; show: 'removing ', each.
		(FileDirectory forFileName: each) deleteFileNamed: each ]
! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 4/24/2002 23:24'!
deleteFilesWhere: oneArgBlock
	"oneArgBlock takes the filename of each file in the environmentPath (see MaArmoredCodeOptions).."

	| fd filenames |

	filenames _ (fd _ FileDirectory on: self environmentPath) fileNames.
	StandardFileStream allInstances do:
		[ :eachStream |
		(filenames includes: eachStream fullName) ifTrue:
			[ Transcript cr; show: 'closing a rogue FileStream for ', eachStream fullName.
			eachStream close ] ].
	filenames do:
		[ :each |
		(oneArgBlock value: each)
			ifTrue:
				[ Transcript cr; show: 'closing rogue filestreams on ', each.
				StandardFileStream allInstances do: 
					[ :eachStream | 
					eachStream fullName = each ifTrue: [ eachStream close ] ].
				Transcript cr; show: 'removing ', each.
				fd deleteFileNamed: each ] ]
! !

!MaTestCase methodsFor: 'initializing' stamp: 'cmm 4/17/2002 23:50'!
initialize

	"nothing to do yet.."
! !

!MaTestCase methodsFor: 'testing' stamp: 'cmm 4/18/2002 00:09'!
isAbstract

	^true! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:54'!
maDebug: aTestResult

	aTestResult maDebugCase: self
! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:56'!
maDebugAsFailure: aTestResult

	aTestResult maDebugCaseAsFailure: self
! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 4/18/2002 22:23'!
performTest

	Transcript cr; show: 'running ', self selector, '.. '.
	super performTest.
	Transcript show: 'complete!!'
! !


!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 7/2/2002 22:44'!
additionalProtocol
	"Any additional protocol needed but not provided by MaNetworkTestPlayer should be answered here."

	^#()
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:32'!
playerNamed: aString

	^self class playerNamed: aString
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:33'!
playersDo: aBlock

	self class playersDo: aBlock! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 22:47'!
pushClass: aClass

	self playersDo: [ :each | each pushClass: aClass ]
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 22:44'!
pushClass: aClass to: playerNameString

	(self playerNamed: playerNameString) pushClass: aClass
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/12/2002 21:48'!
remoteEvaluate: codeString in: playerName

	^(self playerNamed: playerName) remoteEvaluate: codeString
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/7/2002 22:56'!
remotePerform: selectorSymbol in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: Array new! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol with: arg1 in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: (Array with: arg1)
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol withArguments: anArray in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: anArray! !

!MaNetworkTestCase methodsFor: 'printing' stamp: 'cmm 5/3/2002 00:12'!
printOn: aStream

	testSelector
		ifNil: [ aStream nextPutAll: 'a', self class name ]
		ifNotNil: [ super printOn: aStream ]
! !

!MaNetworkTestCase methodsFor: 'setup' stamp: 'cmm 5/27/2002 21:55'!
setUp

	self playersDo: [ :each | each setTestCaseClass: self class ]
! !


!MaTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 14:47'!
setUpSuite
	"Subclasses may implement general set-up code for 
	that should only run once for all tests.  For example,
	network tests maintain a connection to other machines
	that participate in the test.  The facades to these other
	machines needs to be maintained."
! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 15:10'!
tearDownSuite
	"Counterpart to setUpSuite.  See that method for
	more info."
! !

!MaTestCase class methodsFor: 'creation' stamp: 'cmm 4/17/2002 23:40'!
new

	^super new initialize
! !

!MaTestCase class methodsFor: 'testing' stamp: 'cmm 4/18/2002 00:11'!
shouldInheritSelectors

	^false! !


!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 15:15'!
getAddressFor: playerName

	^NetNameResolver addressFromString: (FillInTheBlank request: 'Enter the address of ', playerName)
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 15:16'!
getNextPort

	^NextPort _ NextPort + 1
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:34'!
playerNamed: aString

	^self players at: aString
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:35'!
playersDo: aBlock

	self players do: aBlock! !

!MaNetworkTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 15:24'!
setUpSuite

	super setUpSuite.
	self 
		currentPlayers: Dictionary new;
		initializeNextPort
! !

!MaNetworkTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 15:58'!
tearDownSuite
	"Since a network test suite runs across multiple machines, players images are set up and torn down manually."
! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 6/4/2002 23:08'!
addPlayerNamed: aString

	self
		addPlayerNamed: aString
		at: (self getAddressFor: aString)
		port: self getNextPort
! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 7/28/2002 23:29'!
addPlayerNamed: aString at: hostAddressByteArray port: anInteger
	"The player must first be running and listening on port anInteger.  If this is done, the receiver (which is the conductor) will update all code in the player image, if necessary, and then set its test case to a fresh instance of the receiver."

	(Smalltalk confirm: 'Set up ', hostAddressByteArray printString, ' to listen on port ', anInteger printString)
		ifFalse: [ self error: 'Player ', hostAddressByteArray printString, ' not set up.' ].
	self currentPlayers
		at: aString
		put: 
			(MaNetworkTestPlayerFacade
				name: aString
				hostAddress: hostAddressByteArray
				port: anInteger) connect! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 5/27/2002 15:27'!
initializeNextPort

	NextPort _ 1313
! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/27/2002 15:04'!
currentPlayers
	"We need to rename this variable.  But Squeak appears to have a bug that prevents from recompiling the metaclass."

	^currentSuite
! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/27/2002 15:14'!
currentPlayers: aDictionary
	"key = player name, value = aMaNetworkTestPlayerFacade"

	currentSuite _ aDictionary! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/27/2002 19:36'!
players

	^self currentPlayers
! !


!TestResult methodsFor: 'Running' stamp: 'cmm 4/18/2002 00:54'!
maDebugCase: aTestCase

	aTestCase runCase.
	self passed add: aTestCase
! !

!TestResult methodsFor: 'Running' stamp: 'cmm 4/18/2002 00:56'!
maDebugCaseAsFailure: aTestCase

	aTestCase halt runCase.
	self passed add: aTestCase
! !


!TestSuite methodsFor: 'Running' stamp: 'cmm 4/18/2002 00:39'!
maDebug

	self maRunUsing: #maDebug:
! !

!TestSuite methodsFor: 'Running' stamp: 'cmm 4/18/2002 00:43'!
maDebugAsFailure

	self maRunUsing: #maDebugAsFailure:
! !

!TestSuite methodsFor: 'private' stamp: 'cmm 4/18/2002 00:41'!
maDebug: aResult 

	self
		maExecuteTestsUsing: #maDebug:
		result: aResult
! !

!TestSuite methodsFor: 'private' stamp: 'cmm 4/18/2002 00:42'!
maDebugAsFailure: aResult 

	self
		maExecuteTestsUsing: #maDebugAsFailure:
		result: aResult
! !

!TestSuite methodsFor: 'private' stamp: 'cmm 5/27/2002 19:07'!
maExecuteTestsUsing: aSymbol result: aResult

	self maMarked: 'dev'.
"I couldn't figure out how 'resources' was meant to be used with regard to TestSuites.  I definitely need to maintain testing resources for Magma, but SUnit's implementation with regard to resources seems incomplete.  That's why the only way to properly test Magma is 'MagmaTestCase suite maDebug'."
	self tests isEmpty ifTrue: [ ^self ].
	[ self tests first class setUpSuite.
	self tests do: 
		[:each | 
		self sunitChanged: each.
		each
			perform: aSymbol
			with: aResult ] ] ensure: [ self tests first class tearDownSuite ]
! !

!TestSuite methodsFor: 'private' stamp: 'cmm 4/18/2002 00:38'!
maRunUsing: aSymbol
	| result |
	result := TestResult new.
	self areAllResourcesAvailable ifFalse: [^TestResult signalErrorWith: 'Resource could not be initialized'].
	[ self 
		perform: aSymbol 
		with: result ] 
			sunitEnsure: [self resources do: [:each | each reset ] ].
	^result
! !


!MaNetworkTestCase class reorganize!
('accessing' getAddressFor: getNextPort playerNamed: playersDo:)
('framework' setUpSuite tearDownSuite)
('initializing' addPlayerNamed: addPlayerNamed:at:port: initializeNextPort)
('private' currentPlayers currentPlayers: players)
!


!MaNetworkTestCase reorganize!
('players' additionalProtocol playerNamed: playersDo: pushClass: pushClass:to: remoteEvaluate:in: remotePerform:in: remotePerform:with:in: remotePerform:withArguments:in:)
('private')
('printing' printOn:)
('setup' setUp)
!


!MaTestCase reorganize!
('accessing' environmentPath resourcesPath)
('resources')
('file management' deleteFilesNamed: deleteFilesWhere:)
('initializing' initialize)
('SUnit overrides')
('testing' isAbstract)
('running' maDebug: maDebugAsFailure:)
('private' performTest)
!


!MaSetTestCaseClassRequest reorganize!
('accessing' testCaseClass testCaseClass:)
('private' processFor:)
!


!MaRemotePerformRequest reorganize!
('accessing' arguments arguments: selector selector:)
('private' processFor:)
!


!MaRemoteEvaluateRequest reorganize!
('accessing' codeString codeString: processFor:)
!


!MaPushCodeRequest reorganize!
('accessing' stream stream:)
('private' processFor:)
!


!MaNetworkTestPlayerFacade class reorganize!
('creation' hostAddress:port: name:hostAddress:port:)
!

MaNetworkTestPlayerFacade removeSelector: #getVersionOf:!
MaNetworkTestPlayerFacade removeSelector: #updateAllChangeSets!
MaNetworkTestPlayerFacade removeSelector: #updateChangeSetNamed:!

!MaNetworkTestPlayerFacade reorganize!
('initializing' connect link: name:)
('private' pushChangeSetNamed: pushClass: pushCode:)
('player access' hostAddress name remoteEvaluate: remotePerform:withArguments: setTestCaseClass:)
!

MaNetworkTestPlayer removeSelector: #loadedVersionOf:!

!MaNetworkTestPlayer reorganize!
('actions' loadCodeFrom: protocol remoteEvaluate: remotePerform:withArguments: setTestCaseClass:)
('request framework requirements' processRequest:)
!

"Postscript:
"
MaArmoredCodeOptions reset!

