'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 25 July 2002 at 11:25:22 pm'!
"Change Set:		MaBaseAdditions
Date:			24 December 2001
Author:			Chris Muller

This change set contains additions to the base Smalltalk language.  It does not include ide enhancements such as extensions to browsers."!

Magnitude subclass: #MaNegative
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance '
	poolDictionaries: ''
	category: 'Ma base classes-temporary'!

!MaNegative commentStamp: 'cmm 7/23/2002 20:42' prior: 0!
This class is my tempoarary representation of an infinite number that can be compared against 64-bit LargePositiveIntegers.!

Object subclass: #MaObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base classes-Abstractions'!
MaObject subclass: #MaByteArrayConstants
	instanceVariableNames: ''
	classVariableNames: 'BitMultipliers '
	poolDictionaries: ''
	category: 'System-Support'!

!MaByteArrayConstants commentStamp: '<historical>' prior: 0!
This class' only purpose is to cache the bitMultipliers used by ByteArray>>uint:at: and ByteArray>>uint:at:put:!

MaObject subclass: #MaFilename
	instanceVariableNames: 'string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base classes-temporary'!

!MaFilename commentStamp: '<historical>' prior: 0!
This class is useful for accessing and manipulating file names and
individual components of a file name.

Anatomy of a filename (according to this class)
==============================

Our models to describe will be:

	Model A:  c:\temp\chris.sso
	Model B:  chris.sso

For Model A
-------------
#drive = 'c:'
#path = 'c:\temp'
#pathComponent = '\temp'
#base = 'c:\temp\chris'
#baseComponent = 'chris'
#extension = 'sso'
#fileName = 'chris.sso'
!

PluggableListMorph subclass: #MaPluggableListMorphOfMany
	instanceVariableNames: 'dragOnOrOff getSelectionListSelector setSelectionListSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!MaPluggableListMorphOfMany commentStamp: 'cmm 7/23/2002 20:48' prior: 0!
I use this in the TracingMessagesBrowser because it's more usable for selecting ranges of methods.  There are a few minor enhancements, for example, you can drag the mouse as fast as you want and it won't miss any methods.!

Magnitude subclass: #MaPositive
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance '
	poolDictionaries: ''
	category: 'Ma base classes-temporary'!

!MaPositive commentStamp: 'cmm 7/23/2002 20:49' prior: 0!
This class is my tempoarary representation of an infinite number that can be compared against 64-bit LargePositiveIntegers.!

MaObject subclass: #MaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base classes-Abstractions'!
MaSingleton class
	instanceVariableNames: 'current '!
MaObject subclass: #MaTextMessage
	instanceVariableNames: 'string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base classes-Tools'!

!MaTextMessage commentStamp: 'cmm 7/23/2002 20:50' prior: 0!
This little tool helps you build non-wimpy message strings.!


!Object methodsFor: 'accessing'!
maEmptyString

	"Empty strings occur in many places in Smalltalk code.
	By using this accessor, we can canonicalize these to use
	one empty string, thus cutting down on the number of total
	objects in the system."

	^''
! !

!Object methodsFor: 'accessing'!
maInstSize
	"Answer the number of named and indexed instance variables referenced by
	the receiver."

	^self class instSize + self basicSize
! !

!Object methodsFor: 'accessing'!
maInstVarNameAt: index
	"Return the value of the instance variable named aString.
	If index refers to one of the receivers indexed variables,
	answer the integer index number of the instance variable."

	| numberOfNamed |

	numberOfNamed := self class instSize.
	^index > numberOfNamed
		ifTrue:
			[ (index - numberOfNamed) printString ]
		ifFalse:
			[ self class maAllInstVarNames at: index ]
! !

!Object methodsFor: 'accessing'!
maInstVarNamed: aString
	"Return the value of the instance variable named aString"

	^self instVarAt: (self class allInstVarNames indexOf: aString)
! !

!Object methodsFor: 'copying' stamp: 'cmm 7/24/2002 20:46'!
maShallowCopy

	^self shallowCopy! !

!Object methodsFor: 'printing' stamp: 'cm 12/29/2001 01:14'!
maPrintAbbreviatedOn: aStream
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"
! !

!Object methodsFor: 'printing'!
maPrintAttribute: aSymbol on: aStream

	(self class allInstVarNames includes: aSymbol asString)
		ifTrue:
			[ self
				maPrintInstVar: aSymbol
				on: aStream ]
		ifFalse:
			[ self
				maPrintSelector: aSymbol
				on: aStream ]
! !

!Object methodsFor: 'printing'!
maPrintAttributes: arrayOfSymbols on: aStream

	arrayOfSymbols do:
		[ :each |
		self
			maPrintAttribute: each
			on: aStream ]
! !

!Object methodsFor: 'printing'!
maPrintInstVar: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' = '.
	value := self maInstVarNamed: aSymbol asString.
	(value maIsCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: 'printing' stamp: 'cmm 1/27/2002 23:09'!
maPrintSelector: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' : '.
	value :=
		[ self perform: aSymbol ]
			on: Error
			do: [ :exc | exc exitWith: exc argument ].
	(value maIsCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: 'testing' stamp: 'cmm 1/24/2002 14:05'!
maIsClass

	^false
! !

!Object methodsFor: 'testing'!
maIsCollection

	^false
! !

!Object methodsFor: 'testing'!
maIsEmpty

	^false
! !

!Object methodsFor: 'building'!
maInstVarNamed: aString put: anObject

	"Set the value of the instance variable named aString to
	anObject"

	self
		instVarAt: (self class allInstVarNames indexOf: aString)
		put: anObject
! !

!Object methodsFor: 'not categorized' stamp: 'cmm 5/3/2002 00:02'!
maMarked: aString
	"This is a marker method used to indicate that we wish to come back and re-examine
	code in the future for possible improvement.  For now, try to keep improvements categorized
	via anEsAtom that we can Browse References to, if necessary.  The possibilities should be:

		'ugly'
		'performance'
		'bug'
		'dev'
		'platformSpecific'
		'compilerSpecific'
		'deprecated'

	A *comment* then should follow to provide more detail."

	(#('ugly' 'performance' 'bug' 'dev' 'platformSpecific' 'compilerSpecific' 'deprecated' 'debug helper') includes: aString)
		ifFalse:
			[ Transcript
				cr;
				show: aString printString , ' is not valid code-marker.' ]
! !


!Behavior methodsFor: 'accessing'!
maAllInstVarNames

	^self withAllSuperclasses
		inject: OrderedCollection new
		into:
			[ :coll :each |
			coll
				addAll: each instVarNames;
				yourself ]
! !


!Character methodsFor: 'copying' stamp: 'cmm 7/24/2002 20:44'!
maShallowCopy
	"Characters are unique."

	^self
! !


!Class methodsFor: 'testing' stamp: 'cmm 1/24/2002 14:04'!
maIsClass

	^true
! !


!Collection methodsFor: 'accessing' stamp: 'cmm 1/17/2002 00:45'!
maConform: aBlock

	self 
		do: [ :element | (aBlock value: element) ifFalse: [ ^false ] ].
	^true
! !

!Collection methodsFor: 'testing' stamp: 'cmm 7/9/2002 22:59'!
maConsistsOf: aCollection
	"Answer whether the receiver and aCollection reference all equal
	objects, including the same number of references to those objects.  Order
	is not a factor."

	^self size = aCollection size and: [ self maIncludesAll: aCollection ]
! !

!Collection methodsFor: 'testing' stamp: 'cmm 7/9/2002 23:02'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	self size > 20
		ifTrue:
			[ ^self asBag maIncludesAll: aCollection ].
	otherColl :=
		aCollection maIsBag
			ifTrue:
				[ aCollection ]
			ifFalse:
				[ aCollection size > 20
					ifTrue:
						[ aCollection asBag ]
					ifFalse:
						[ aCollection ] ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true
! !

!Collection methodsFor: 'testing' stamp: 'cmm 7/9/2002 23:01'!
maIncludesAllUnique: aCollection
	"Return true if the receiver includes at least one of
	each unique element in aCollection."

	| compareCollection |

	compareCollection :=
		aCollection size > 20
			ifTrue:
				[ aCollection ]
			ifFalse:
				[ aCollection maIsSet ifTrue: [ aCollection ] ifFalse: [ aCollection asSet ] ].
	self do: [ :each | (compareCollection includes: each) ifFalse: [ ^false ] ].
	^true
! !

!Collection methodsFor: 'testing'!
maIncludesWhere: aBlock 
	"Answer whether any element in the receiver can make aBlock answer true."

	^self 
		maDetect: aBlock
		ifFound: [:foundObject | true]
		ifNone: [false]! !

!Collection methodsFor: 'testing'!
maIsBag
	^false! !

!Collection methodsFor: 'testing'!
maIsCollection

	^true
! !

!Collection methodsFor: 'testing'!
maIsEmpty

	^self isEmpty
! !

!Collection methodsFor: 'testing'!
maIsSequenceable
	"Return whether the receiver is an ordered type of
	of collection.  Default is false."

	^false! !

!Collection methodsFor: 'testing'!
maIsSet

	^false
! !

!Collection methodsFor: 'testing'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection.  In SequencableCollections, the order must be
	the same as well."

	^self maConsistsOf: anotherCollection
! !

!Collection methodsFor: 'testing'!
maNotEmpty

	^self notEmpty
! !

!Collection methodsFor: 'testing'!
maOccurrencesWhere: aBlock
	"Answer the number of elements that satisfy aBlock."

	| count |

	count := 0.
	self do: [ :each | (aBlock value: each) ifTrue: [ count := count + 1 ] ].
	^count
! !

!Collection methodsFor: 'cldt-api' stamp: 'cmm 1/16/2002 16:48'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!Collection methodsFor: 'actions'!
maRemoveAll: aCollection forEachAbsent: aBlock

	^aCollection do:
		[ :element |
		self
			remove: element
			ifAbsent: [ aBlock value: element ] ]
! !


!Bag methodsFor: 'accessing'!
maAnyElement

	^self detect: [ :each | true ]
! !

!Bag methodsFor: 'testing' stamp: 'cmm 7/9/2002 23:01'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	otherColl :=
		aCollection maIsBag
			ifTrue:
				[ aCollection ]
			ifFalse:
				[ aCollection size > 20
					ifTrue:
						[ aCollection asBag ]
					ifFalse:
						[ aCollection ] ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true
! !

!Bag methodsFor: 'testing'!
maIsBag
	^true! !

!Bag methodsFor: 'testing'!
maIsHashedCollection

	^true
! !

!Bag methodsFor: 'printing' stamp: 'cmm 1/23/2002 00:18'!
printOn: aStream

	aStream
		nextPutAll: (self class name first isVowel ifTrue: [ 'an ' ] "$NON-NLS$" ifFalse: [ 'a ' ]). "$NON-NLS$"
	self class printOn: aStream.
	contents keysAndValuesDo:
		[ :eachKey :eachValue |
		aStream
			cr; tab;
			nextPut: $(;
			maPrint: eachValue;
			nextPutAll: ') ';
			maPrint: eachKey ]
! !


!Date methodsFor: 'accessing'!
maQuarterIndex

	"Returns the quarter number of the receiver."

	(#(1 2 3) includes: self monthIndex) ifTrue: [ ^1 ].
	(#(4 5 6) includes: self monthIndex) ifTrue: [ ^2 ].
	(#(7 8 9) includes: self monthIndex) ifTrue: [ ^3 ].
	(#(10 11 12) includes: self monthIndex) ifTrue: [ ^4 ]! !

!Date methodsFor: 'accessing'!
maTotalMonths

	^self year * 12 + self monthIndex! !

!Date methodsFor: 'actions'!
maAddMonths: anInteger

	"Returns a new instance of the receiver resulting from adding anInteger months
	to it."

	| totalMonths newMonth newYear |

	totalMonths := self maTotalMonths + anInteger.
	newMonth := totalMonths rem: 12.
	newMonth = 0 ifTrue: [ newMonth := 12 ].
	newYear := (totalMonths - 1) // 12.
	^self class
		newDay: self dayOfMonth
		monthIndex: newMonth
		year: newYear! !


!FileDirectory methodsFor: 'file name utilities' stamp: 'cmm 4/8/2002 20:52'!
maEntriesMatching: pat
	"FileDirectory default fileNamesMatching: '*'"

	^ self entries select: [ :each | pat match: each name ]
! !


!MaNegative methodsFor: 'testing'!
< anObject

	^true
! !

!MaNegative methodsFor: 'printing'!
printOn: aStream

	aStream nextPutAll: '-infinity'
! !

!MaNegative methodsFor: 'converting' stamp: 'cmm 2/13/2002 00:37'!
adaptToInteger: aNumber andSend: aSelector

	^(self
		perform: aSelector 
		with: aNumber) not
! !


!MaNegative class methodsFor: 'accessing'!
infinity
	^SoleInstance! !

!MaNegative class methodsFor: 'initializing'!
initialize

	SoleInstance := self new
! !


!MaObject methodsFor: 'private creation' stamp: 'cmm 4/23/2002 19:51'!
copyAttributes: anArray from: sourceObject

	anArray do:
		[ :each |
		self
			maInstVarNamed: each
			put: (sourceObject maInstVarNamed: each) copy ]
! !

!MaObject methodsFor: 'private creation' stamp: 'cmm 4/23/2002 19:35'!
copyWithAttributes: anArray
	"anArray of instVar names in the receiver."

	| copy |

	^(copy := super copy)
		copyAttributes: anArray
		from: copy
! !

!MaObject methodsFor: 'private initializing'!
initialize

	"Default, do nothing."
! !

!MaObject methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !


!MaFilename methodsFor: 'accessing'!
asString

	^self string
! !

!MaFilename methodsFor: 'accessing'!
base

	^self upTo: 'base'
! !

!MaFilename methodsFor: 'accessing'!
baseComponent

	^self hasExtension
		ifTrue:
			[ self string
				copyFrom: (self indexOfLastPathDelimiter + 1 max: 1)
				to: self indexOfDotDelimiter - 1 ]
		ifFalse:
			[ self string
				copyFrom: (self indexOfLastPathDelimiter + 1 max: 1)
				to: self size ]
! !

!MaFilename methodsFor: 'accessing'!
drive

	^self hasDrive
		ifTrue:
			[ self string
				copyFrom: 1
				to: 2 ]
		ifFalse:
			[ self maEmptyString ]
! !

!MaFilename methodsFor: 'accessing'!
extension

	^self hasExtension
		ifTrue:
			[ self string
				copyFrom: self indexOfDotDelimiter + 1
				to: self size ]
		ifFalse:
			[ self maEmptyString ]
! !

!MaFilename methodsFor: 'accessing'!
fileName

	^self hasPath
		ifTrue:
			[ self string
				copyFrom: self indexOfLastPathDelimiter + 1
				to: self size ]
		ifFalse:
			[ self string ]
! !

!MaFilename methodsFor: 'accessing'!
path

	^self hasPath
		ifTrue:
			[ self upTo: 'path' ]
		ifFalse:
			[ self maEmptyString ]
! !

!MaFilename methodsFor: 'accessing'!
pathComponent
	"Answer just the path component without the drive."

	^self hasPath
		ifTrue:
			[ self string
				copyFrom: self indexOfFirstPathDelimiter
				to: self indexOfLastPathDelimiter - 1 ]
		ifFalse:
			[ self maEmptyString ]
! !

!MaFilename methodsFor: 'accessing'!
size

	^self string size
! !

!MaFilename methodsFor: 'building'!
baseComponent: aString

	self string: (
		(WriteStream on: String new)
			nextPutAll: self path;
			nextPut: self pathDelimiter;
			nextPutAll: aString;
			nextPut: self dotDelimiter;
			nextPutAll: self extension;
			contents)
! !

!MaFilename methodsFor: 'building'!
extension: aString

	| base |

	base := self base.
	self string: (
		(WriteStream on: (String new: base size + self dotDelimiterSize + aString size))
			nextPutAll: base;
			nextPut: self dotDelimiter;
			nextPutAll: aString;
			contents)
! !

!MaFilename methodsFor: 'building'!
path: aString

	self string: (
		(WriteStream on: String new)
			nextPutAll: aString;
			nextPut: self pathDelimiter;
			nextPutAll: self fileName;
			contents)
! !

!MaFilename methodsFor: 'creation'!
copyWithExtension: aString

	^self copy extension: aString
! !

!MaFilename methodsFor: 'private accessing'!
dotDelimiter

	^$.
! !

!MaFilename methodsFor: 'private accessing'!
dotDelimiterSize

	^1
! !

!MaFilename methodsFor: 'private accessing'!
driveDelimiter

	^$:
! !

!MaFilename methodsFor: 'private accessing'!
indexOfDotDelimiter

	^self string indexOf: self dotDelimiter
! !

!MaFilename methodsFor: 'private accessing'!
indexOfFirstPathDelimiter

	^self string indexOf: self pathDelimiter
! !

!MaFilename methodsFor: 'private accessing'!
indexOfLastPathDelimiter

	self string size
		to: 1
		by: -1
		do: [ :index | (self string at: index) = self pathDelimiter ifTrue: [ ^index ] ].
	^0
! !

!MaFilename methodsFor: 'private accessing' stamp: 'cmm 4/8/2002 22:30'!
pathDelimiter

	^FileDirectory pathNameDelimiter
! !

!MaFilename methodsFor: 'private accessing'!
string

	^string! !

!MaFilename methodsFor: 'private accessing'!
upTo: componentName
	"Answer a copy of the receivers string with all of the components
	up to componentName.  The order of the components is:
	drive + path + base + extension.  The receiver must have a full
	path name including drive."

	| stream |

	componentName = 'extension' ifTrue: [ ^self string ].
	stream := WriteStream on: String new.
	stream nextPutAll: self drive.
	componentName = 'drive' ifTrue: [ ^stream contents ].
	stream nextPutAll: self pathComponent.
	componentName = 'path' ifTrue: [ ^stream contents ].
	stream
		nextPut: self pathDelimiter;
		nextPutAll: self baseComponent.
	^stream contents
! !

!MaFilename methodsFor: 'testing'!
hasDrive

	^self string size > 1 and: [ (self string at: 2) = self driveDelimiter ]
! !

!MaFilename methodsFor: 'testing'!
hasExtension

	^(self string indexOf: self dotDelimiter) > 0
! !

!MaFilename methodsFor: 'testing'!
hasPath

	^(self string indexOf: self pathDelimiter) > 0
! !

!MaFilename methodsFor: 'private initializing'!
initialize

	super initialize.
	string := self maEmptyString
! !

!MaFilename methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:24'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self string
! !

!MaFilename methodsFor: 'private building'!
string: aString

	string := aString
! !


!MaObject class methodsFor: 'instance creation'!
new

	^super new initialize
! !


!MaByteArrayConstants class methodsFor: 'accessing' stamp: 'cmm 1/23/2002 00:55'!
bitMultipliers

	^BitMultipliers
! !

!MaByteArrayConstants class methodsFor: 'private initializing' stamp: 'cmm 1/23/2002 00:52'!
initialize

	self initializeBitMultipliers
! !

!MaByteArrayConstants class methodsFor: 'private initializing' stamp: 'cmm 1/23/2002 00:54'!
initializeBitMultipliers

	BitMultipliers _ (Array new: 256).
	1
		to: 256
		do:
			[ :index | 
				BitMultipliers 
					at: index 
					put: (256 raisedTo: index - 1) ]
! !


!MaFilename class methodsFor: 'creation'!
fromString: aString
	"aString may be a simple filename.ext or a full path."

	^self new string: aString
! !


!MaPluggableListMorphOfMany methodsFor: 'initialization' stamp: 'cmm 1/18/2002 16:08'!
list: listOfStrings
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty ifTrue: [^ self selectedMorph: nil].
	super list: listOfStrings.

	"At this point first morph is sensitized, and all morphs share same handler."
	scroller firstSubmorph on: #mouseEnterDragging
						send: #mouseEnterDragging:onItem:
						to: self.
	scroller firstSubmorph on: #mouseUp
						send: #mouseUp:onItem:
						to: self.
	"This should add this behavior to the shared event handler thus affecting all items"! !

!MaPluggableListMorphOfMany methodsFor: 'initialization' stamp: 'cmm 1/18/2002 16:08'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel keystroke: keyActionSel
	"setup a whole load of pluggability options"
	getSelectionListSelector _ getListSel.
	setSelectionListSelector _ setListSel.
	super on: anObject list: listSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel
! !

!MaPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'cmm 1/18/2002 16:08'!
drawOn: aCanvas
	| onMorph |
	super drawOn: aCanvas.
	1 to: list size do:  "NOTE: should be optimized to only visible morphs"
		[:index |
		(self listSelectionAt: index) ifTrue:
			[onMorph _ scroller submorphs at: index.
			aCanvas fillRectangle:
				(((scroller transformFrom: self) localBoundsToGlobal: onMorph bounds)
						intersect: scroller bounds)
				color: color darker]]! !

!MaPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'cmm 1/18/2002 16:08'!
listSelectionAt: index
	getSelectionListSelector ifNil:[^false].
	^model perform: getSelectionListSelector with: index! !

!MaPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'cmm 1/18/2002 16:08'!
listSelectionAt: index put: value
	setSelectionListSelector ifNil:[^false].
	^model perform: setSelectionListSelector with: index with: value! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/20/2002 00:05'!
mouseDown: event
	| index aMorph |

	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].
	aMorph _ self itemFromPoint: event position.
	aMorph ifNil:[^super mouseDown: event].
	model okToChange ifFalse: [^ self].  "No change if model is locked"
	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].

	"Inform model of selected item and let it toggle."
	self
		changeModelSelection: index
		shifted: event shiftPressed
		controlled: event controlKeyPressed.

	event hand releaseMouseFocus: aMorph.
	submorphs do: [ :each | each changed ]
! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/18/2002 17:55'!
mouseMove: event
	"The mouse has moved, as characterized by the event provided.  Adjust the scrollbar, and alter the selection as appropriate"

	| index aMorph |
	event position y < self top
		ifTrue:
			[scrollBar scrollUp: 1.
			aMorph _ self itemFromPoint: scroller topLeft + (1@1)]
		ifFalse:
			[event position y > self bottom
				ifTrue:
					[scrollBar scrollDown: 1.
					aMorph _ self itemFromPoint: scroller bottomLeft + (1@-1)]
				ifFalse:
					[aMorph _ self itemFromPoint: event position]].
	aMorph ifNil: [^ super mouseDown: event].

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].

	"Inform model of selected item and let it toggle."
	self
		changeModelSelection: index
		shifted: true
		controlled: event controlKeyPressed.
	self maMarked: 'performance'.  "this may be a performance issue, especially when dragging.."
	submorphs do: [ :each | each changed ]
! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/18/2002 17:45'!
mouseUp: event
	"Not needed.  Overridden to do nothing."! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/18/2002 16:08'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	^ super update: aSymbol! !

!MaPluggableListMorphOfMany methodsFor: 'obsolete' stamp: 'cmm 1/18/2002 16:08'!
mouseDown: event onItem: aMorph
	self removeObsoleteEventHandlers.! !

!MaPluggableListMorphOfMany methodsFor: 'obsolete' stamp: 'cmm 1/18/2002 16:08'!
mouseEnterDragging: event onItem: aMorph
	self removeObsoleteEventHandlers.! !

!MaPluggableListMorphOfMany methodsFor: 'obsolete' stamp: 'cmm 1/18/2002 16:08'!
mouseUp: event onItem: aMorph
	self removeObsoleteEventHandlers.! !

!MaPluggableListMorphOfMany methodsFor: 'model access' stamp: 'cmm 1/18/2002 17:49'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."

	^self
		changeModelSelection: anInteger
		shifted: Sensor shiftPressed
		controlled: Sensor controlKeyPressed
! !

!MaPluggableListMorphOfMany methodsFor: 'model access' stamp: 'cmm 1/18/2002 16:50'!
changeModelSelection: anInteger shifted: shiftedBoolean controlled: controlledBoolean
	"Change the model's selected item index to be anInteger."

	setIndexSelector ifNotNil:
		[ model 
			perform: setIndexSelector 
			with: anInteger
			with: shiftedBoolean
			with: controlledBoolean ]
! !


!MaPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'cmm 1/18/2002 16:08'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel
	^ self new
		on: anObject
		list: listSel
		primarySelection: getSelectionSel
		changePrimarySelection: setSelectionSel
		listSelection: getListSel
		changeListSelection: setListSel
		menu: getMenuSel
		keystroke: #arrowKey:from:		"default"! !

!MaPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'cmm 1/18/2002 16:08'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel keystroke: keyActionSel 
	^ self new
		on: anObject
		list: listSel
		primarySelection: getSelectionSel
		changePrimarySelection: setSelectionSel
		listSelection: getListSel
		changeListSelection: setListSel
		menu: getMenuSel
		keystroke: keyActionSel! !


!MaPositive methodsFor: 'testing'!
< anObject

	^false
! !

!MaPositive methodsFor: 'testing'!
printOn: aStream

	aStream nextPutAll: 'infinity'
! !

!MaPositive methodsFor: 'converting' stamp: 'cmm 2/13/2002 00:34'!
adaptToInteger: aNumber andSend: aSelector

	^(self 
		perform: aSelector 
		with: aNumber) not
! !


!MaPositive class methodsFor: 'accessing'!
infinity
	^SoleInstance! !

!MaPositive class methodsFor: 'initializing'!
initialize

	SoleInstance := self new
! !


!MaSingleton class methodsFor: 'accessing'!
current

	^current
! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/30/2002 00:43'!
reset
	
	current _ self new
! !


!MaTextMessage methodsFor: 'accessing'!
text

	(self string notEmpty and: [ self string last = $. ]) ifFalse: [ self append: $. ].
	^self string
! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 3/6/2002 22:47'!
append: aString

	self appendString: aString
! !

!MaTextMessage methodsFor: 'building'!
appendAndedList: aCollection

	self
		appendList: (
			aCollection
				collect: [ :each | each isString ifTrue: [ each ] ifFalse: [ each printString ] ])
		with: ' and '
! !

!MaTextMessage methodsFor: 'building'!
appendCount: aNumber of: aString
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self
		append: aNumber;
		space.
	self
		appendProperlyPluralized: aString
		for: aNumber
! !

!MaTextMessage methodsFor: 'building'!
appendProperlyPluralized: aString for: aNumber
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	^self append: (
		(aNumber
			between: 0
			and: 1)
				ifTrue:
					[ aString ]
				ifFalse:
					[ (aString
						maEndsWith: 's'
						ignoringCase: true)
							ifTrue:
								[ aString copyWith: $' ]
							ifFalse:
								[ aString copyWith: $s ] ])
! !

!MaTextMessage methodsFor: 'building'!
space

	self append: $ 
! !

!MaTextMessage methodsFor: 'private accessing'!
string

	^string
! !

!MaTextMessage methodsFor: 'private building'!
appendString: aString

	string := self string, (aString isString ifTrue: [ aString ] ifFalse: [ aString printString ])
! !

!MaTextMessage methodsFor: 'private initializing'!
appendList: aCollection with: aString

	| index |

	aCollection isEmpty ifTrue: [ ^nil ].
	index := 1.
	aCollection do:
		[ :each |
		self append: each.
		aCollection size > 1
			ifTrue:
				[ index < (aCollection size - 1)
					ifTrue:
						[ self append: ', ' ]
					ifFalse:
						[ index = (aCollection size - 1) ifTrue: [ self append: aString ] ] ].
		index := index + 1 ]
! !

!MaTextMessage methodsFor: 'private initializing'!
initialize

	super initialize.
	string := ''
! !


!MethodReference methodsFor: 'queries' stamp: 'cmm 2/7/2002 23:41'!
maActualMethod

	| class |
	^(class _ self actualClass)
		ifNil: [ nil ]
		ifNotNil: [ class >> self methodSymbol ]
! !


!Number methodsFor: 'testing'!
maIsFraction

	^false
! !

!Number methodsFor: 'printing' stamp: 'cm 12/24/2001 16:40'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !


!Fraction methodsFor: 'testing'!
maIsFraction

	^true
! !


!Integer methodsFor: 'testing'!
maIsPrime

	self even ifTrue: [ ^false ].
	3
		to: (self // 2)
		do: [ :divisor | (self \\ divisor) ~= (self - divisor) ifTrue: [ ^false ] ].
	^true
! !

!Integer methodsFor: 'bit manipulation' stamp: 'cmm 1/24/2002 13:52'!
maClearBit: index

	"Return the receiver with the bit at index clear."

	^self bitAnd: (1 bitShift: index - 1) bitInvert! !

!Integer methodsFor: 'bit manipulation' stamp: 'cmm 2/15/2002 00:24'!
maIsBitSet: bitPosition

	^self allMask: (2 raisedTo: bitPosition-1)
! !

!Integer methodsFor: 'bit manipulation' stamp: 'cmm 1/24/2002 13:52'!
maSetBit: index

	"Return the receiver with the bit at index set."

	^self bitOr: (1 bitShift: index - 1)! !


!SequenceableCollection methodsFor: 'accessing'!
maAnyElement

	^self first
! !

!SequenceableCollection methodsFor: 'accessing'!
maIndexOfLast: element

	self size
		to: 1
		by: -1
		do: [ :index | (self at: index) = element ifTrue: [ ^index ] ].
	^0
! !

!SequenceableCollection methodsFor: 'testing'!
maIsSequenceable
	"Return whether the receiver is an ordered type of
	of collection.  Default is false."

	^true! !

!SequenceableCollection methodsFor: 'testing'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection and in the same order."

	self size = anotherCollection size ifFalse: [ ^false ].
	self
		with: anotherCollection
		do: [ :eachInSelf :eachInOther | eachInSelf = eachInOther ifFalse: [ ^false ] ].
	^true
! !


!ByteArray methodsFor: 'accessing' stamp: 'cmm 1/23/2002 00:55'!
uint: bits at: anInteger

	| sum index |

	sum := 0.
	index := 1.
	anInteger + 1
		to: anInteger + (bits // 8)
		do:
			[ :pos |
			sum := sum + ((MaByteArrayConstants bitMultipliers at: index) * (self at: pos)).
			index := index + 1 ].
	^sum
! !

!ByteArray methodsFor: 'building'!
uint: bits at: position put: anInteger

	| value |

	value := anInteger.
	position + 1
		to: position + (bits // 8)
		do:
			[ :pos |
			self
				at: pos
				put: value \\ 256.
			value := value // 256 ].
	^anInteger
! !


!CompiledMethod methodsFor: 'accessing' stamp: 'cmm 2/17/2002 16:16'!
maMethodClass

	^self who first
! !


!DirectoryEntry methodsFor: 'access' stamp: 'cm 1/2/2002 16:51'!
maExtension

	| indexOfLastDot |
	indexOfLastDot _ self name lastIndexOf: FileDirectory dot asCharacter.
	^(indexOfLastDot
		between: 1
		and: self name size - 1)
			ifTrue:
				[ self name
					copyFrom: indexOfLastDot+1
					to: self name size ]
			ifFalse: [ self maEmptyString ]
! !


!Interval methodsFor: 'accessing'!
maGapBetween: anInterval 
	"Returns the interval that is the gap between the
	receiver and anInterval.  The by is copied from the
	receiver.  If the receiver and anInterval intersect,
	return nil."

	(self maIntersects: anInterval) 
		ifFalse: 
			[| endPoints |
			endPoints := (Array 
						with: self to
						with: self from
						with: anInterval to
						with: anInterval from) asSortedCollection.
			^self class 
				from: (endPoints at: 2)
				to: (endPoints at: 3)
				by: self by].
	^nil! !

!Interval methodsFor: 'accessing'!
maIntersectionOf: anInterval 
	"Returns the interval that is the overlap between the
	receiver and anInterval.  The by is copied from the
	receiver."

	(self maIntersects: anInterval) 
		ifTrue: 
			[| endPoints |
			endPoints := (Array 
						with: self to
						with: self from
						with: anInterval to
						with: anInterval from) asSortedCollection.
			^self class 
				from: (endPoints at: 2)
				to: (endPoints at: 3)
				by: self by].
	^nil! !

!Interval methodsFor: 'testing'!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(self from between: anInterval from and: anInterval to) 
		or: [anInterval from between: self from and: self to]! !


!OrderedCollection methodsFor: 'adding' stamp: 'cm 1/7/2002 16:25'!
maAddAll: aSequenceableCollection afterIndex: integerIndex

	aSequenceableCollection reverseDo: [:each | self add: each afterIndex: integerIndex ].
	^aSequenceableCollection
! !


!Set methodsFor: 'accessing'!
maAnyElement

	^self detect: [ :each | true ]
! !

!Set methodsFor: 'copying' stamp: 'cmm 7/24/2002 20:41'!
maShallowCopy

	| copy |
	copy _ self species new: self size.
	self do: [ :each | copy add: each ].
	^copy! !

!Set methodsFor: 'testing'!
maIncludesAllUnique: aCollection

	aCollection do: [ :each | (self includes: each) ifFalse: [ ^false ] ].
	^true
! !

!Set methodsFor: 'testing'!
maIsHashedCollection

	^true
! !

!Set methodsFor: 'testing'!
maIsSet

	^true
! !


!Dictionary methodsFor: 'accessing'!
maAllKeysAtValue: anObject

	| aCollection |

	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection! !

!Dictionary methodsFor: 'testing'!
maIsHashedCollection

	^true
! !

!Dictionary methodsFor: 'private' stamp: 'cmm 7/24/2002 20:45'!
maShallowCopy

	| copy |
	copy _ self species new.  "new: seems buggy w/ Dictionaries.."
	self keysAndValuesDo: 
		[ :eachKey :eachValue | copy at: eachKey put: eachValue ].
	^copy! !

!Dictionary methodsFor: 'actions'!
maAt: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock

	| current uniqueObj |

	uniqueObj := 'x'.
	^(current := self
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj
			ifTrue: [ zeroArgBlock value ]
			ifFalse: [ oneArgBlock value: current ]
! !


!String methodsFor: 'converting'!
maAsIntegerFromRadix: anInteger
	"Answer a Smalltalk Integer with an equivalent value of the receiver
	represented in radix anInteger."

	^self
		inject: 0
		into: [ :sum :character | (sum * anInteger) + character digitValue ]
! !

!String methodsFor: 'converting'!
maFormattedForPlural: aNumber

	"This is kind of a wing-nut method, but it can save you some
	redundant code if you wish to make your application plural
	and singular friendly.  It will add or remove an s based on
	aNumber and whether or not the receiver already ends in s."

	^aNumber > 0 & (aNumber <= 1)
		ifTrue:
			[ "should not end in s"
			(self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ self
							copyFrom: 1
							to: self size - 1 ]
					ifFalse:
						[ self ] ]
		ifFalse:
			[ (self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ "should end in s"
						self ]
					ifFalse:
						[ self , 's' ] ]! !

!String methodsFor: 'printing' stamp: 'cm 12/24/2001 16:39'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !

!String methodsFor: 'testing'!
maBeginsWith: aString

	"Returns true if the receiver begins with the elements in aString"

	aString size > self size ifTrue: [ ^false ].
	^(self
		copyFrom: 1
		to: aString size) = aString! !

!String methodsFor: 'testing'!
maBeginsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase maBeginsWith: aString asLowercase ]
		ifFalse:
			[ self maBeginsWith: aString ]! !

!String methodsFor: 'testing' stamp: 'cmm 1/23/2002 01:24'!
maEndsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase endsWith: aString asLowercase ]
		ifFalse:
			[ self endsWith: aString ]! !


!UndefinedObject methodsFor: 'testing'!
maIsEmpty

	^true
! !

!UndefinedObject methodsFor: 'testing'!
maNotEmpty

	^false
! !


!WriteStream methodsFor: 'accessing' stamp: 'cm 12/24/2001 16:03'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!WriteStream methodsFor: 'printing'!
maPrint: anObject

	anObject isString ifTrue: [ self nextPutAll: anObject ] ifFalse: [ anObject printOn: self ]
! !


!LimitedWriteStream methodsFor: 'accessing' stamp: 'cm 12/24/2001 16:02'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !


!MaTextMessage reorganize!
('accessing' text)
('building' append: appendAndedList: appendCount:of: appendProperlyPluralized:for: space)
('private accessing' string)
('private building' appendString:)
('private initializing' appendList:with: initialize)
!

MaPositive initialize!
MaByteArrayConstants initialize!

!MaByteArrayConstants class reorganize!
('accessing' bitMultipliers)
('private initializing' initialize initializeBitMultipliers)
!

MaNegative initialize!
"Postscript:
initialize all singletons"
MaSingleton withAllSubclassesDo: [ :each | each reset ].
MaByteArrayConstants initialize.
!

